// Copyright (c) 2024 Codemongous LLC. All Rights Reserved.

#pragma once
#include "ISCW_UK2Node.h"

#include <memory>
#include <string>

using std::shared_ptr;
using std::wstring;

namespace Sourcify
{
	class ISCW_UEnum;
	class ISCW_UK2Node_Select : public virtual ISCW_UK2Node
	{
	public:
		virtual ~ISCW_UK2Node_Select() = default;

		virtual shared_ptr<ISCW_UEnum> GetEnum() const = 0;

		virtual void ReloadEnum(shared_ptr<ISCW_UEnum> InEnum) = 0;
		
		virtual std::shared_ptr<ISCW_UK2Node_Select> ToUK2Node_SelectPtr() = 0;
		virtual std::shared_ptr<const ISCW_UK2Node_Select> ToUK2Node_SelectPtr() const = 0;
	};

	using ISCW_UK2Node_SelectConstPtr = std::shared_ptr<const ISCW_UK2Node_Select>;
	using ISCW_UK2Node_SelectPtr = std::shared_ptr<ISCW_UK2Node_Select>;
} // namespace Sourcify